#include<iostream>
#include<vector>
using namespace std;

#include "burgers.h"

#include "dco.hpp"
typedef double DCO_BT;
typedef dco::ga1v<DCO_BT,2*bw> DCO_M;
typedef DCO_M::type DCO_T;
typedef DCO_M::tape_t DCO_TAPE_T;

int main() {
  vector<DCO_T> y(n,0);
  for (int i=1;i<n-1;i++) y[i]=sin(2*PI*i/n);
  DCO_M::global_tape=DCO_TAPE_T::create();
  DCO_M::global_tape->register_variable(y);
  vector<DCO_T> yc(y);
  burgers(yc);  
  for(int i=n/2-bw;i<n/2+bw;i++) 
    DCO_M::global_tape->register_output_variable(yc[i]);
  vector<vector<double>> M_dydy(2*bw,vector<double>(n));
  for(int i=n/2-bw,j=0;i<n/2+bw;i++,j++) 
    dco::derivative(yc[i])[j]=1;
  DCO_M::global_tape->interpret_adjoint();
  for(int i=n/2-bw,k=0;i<n/2+bw;i++,k++)
    for(int j=1;j<n-1;j++) 
      M_dydy[i-n/2+bw][j]=dco::derivative(y[j])[k];
  cerr << dco::size_of(DCO_M::global_tape) << "b" << endl;
  DCO_TAPE_T::remove(DCO_M::global_tape);
  for(int i=n/2-bw;i<n/2+bw;i++) 
    for(int j=1;j<n-1;j++)
      cout << i << " " << j << ": " << M_dydy[i-n/2+bw][j] << endl;
  return 0;
}

