#include <iostream>
#include <vector>
using namespace std;

#include "burgers.h"

#include "dco.hpp"
typedef double DCO_BT;
typedef dco::gt1v<DCO_BT,n>::type DCO_T;

int main() {
  vector<double> y_in(n,0);
  for (int i=1;i<n-1;i++) y_in[i]=sin(2*PI*i/n);
  vector<DCO_T> y(n);
  for (int i=1;i<n-1;i++) {
    y[i]=y_in[i];
    dco::derivative(y[i])[i]=1;
  }
  burgers(y);
  for (int i=1;i<n-1;i++) 
    cout << i << ": " << dco::value(y[i]) << " " << dco::derivative(y[n/2])[i] << endl;
  return 0;
}
